% to run: 

% load anavals_BNUM80_BLEN2_21_SAMP; load anavals_BNUM80_BLEN2_21_SAMP_redistri_pny175.mat;
% USE_WRAPPER=0; USE_REDIR=0; target_errR=0.1; target_errNum=target_errR*3360;  brickest3d 

if USE_WRAPPER == 0
    ROUND_NUM = 10000;
    SHOW_PERIOD = 100;
    SAMPLE_BIT_NUM = 85;
end
  
EST_RECORD = zeros(ROUND_NUM,1);
EST_RECORD_driv = zeros(ROUND_NUM,1);
EST_RECORD_realerrnum = zeros(ROUND_NUM,1);
EST_RECORD_peakval = zeros(ROUND_NUM,1);
EST_RECORD_endval = zeros(ROUND_NUM,1);

FORCE_LINEAR_SCAN = 0;
USE_SAVE = 0;
WITH_IMMUNE=1;

PKT_SIZE = 12000;

GPSZ = 3;

N = 21;
GNUM = N/GPSZ; % group number

actualN = N;

BNUM = 80;
BLEN = 2; 

W = BLEN*BNUM;  
M = W*N; 

maxerr = floor(M*0.175);

estErr = 0;
estErrBase = 0;

blockP = binopdf([0:BNUM],BNUM,0.5);
BNUMp1 = BNUM+1;

PER_SPBLK_B_N = 12;

% for sta begin
simtrans = zeros(BNUM+1,BNUM+1);
recordpktvals = zeros(1,ROUND_NUM*N);
recordpktcodevals = [];

stadistval = [];
sta_brickerr = []; sta_linearerr = [];
% for sta end

errR = target_errR; 
errNum = target_errNum; 
for iteridx=1:ROUND_NUM

    if USE_SAVE == 0 
        pkt = ceil(rand(1,M)-0.5); 
    end
    
    pktval = [];
    pktcolors = [];
    for j=1:actualN
        bgnidx = (j-1) * W + 1; endidx = j * W;
        pktval(j) = findbpat(pkt(bgnidx:endidx),BLEN); 
    end
    for jj=1:GNUM
        thisbgnidx = (jj-1)*GPSZ+1;
        thispktgroup = zeros(1,GPSZ); thispktgroup(1:GPSZ) = pktval(thisbgnidx:thisbgnidx+GPSZ-1);
        pktcolors(jj) = pointmap(thispktgroup(1)+1,thispktgroup(2)+1,thispktgroup(3)+1);
    end
    

    % now adding errors bgn
    if USE_SAVE == 0 
        err = ceil(rand(1,M)-(1-errR)); 
    end
    % now adding errors end
    
    rcv = bitxor(err,pkt);
    realErrNum = sum(err);

    rcvval = [];
    for j=1:actualN
        bgnidx = (j-1) * W + 1; endidx = j * W;
        rcvval(j) = findbpat(rcv(bgnidx:endidx),BLEN); 
    end

    %save lastcase.mat pkt err;        
    validXs = cell(1,GNUM); 
    for jj=1:GNUM
        validXs{jj} = [];
        thisbgnidx = (jj-1)*GPSZ+1;
        thispktcolor = pktcolors(jj);            
        if thispktcolor > 0
            hereallpoints = colormap{thispktcolor}.pntrcd-1; 
            thisrcvgroup = rcvval(thisbgnidx:thisbgnidx+GPSZ-1);
            tempp = repmat(thisrcvgroup,size(hereallpoints,1),1);
            herediff = hereallpoints - tempp;
            sumherediff = sum(abs(herediff'));
            tempp = find(sumherediff' < 30);
            validXs{jj} = hereallpoints(tempp,:);
        else
            fprintf(1, '--- pktval %d %d %d, rcvval %d %d %d\n', pktval(thisbgnidx), pktval(thisbgnidx+1), pktval(thisbgnidx+2), rcvval(thisbgnidx), rcvval(thisbgnidx+1), rcvval(thisbgnidx+2));
        end
    end

    newtonsearchfailed = FORCE_LINEAR_SCAN; % NOTE: to do linear scan, just set this to be 1
    asfarasigo = maxerr;
    likelihood = zeros(1,asfarasigo);
    currpoint = 2; last1std = 1000; histpoint = [];
    for newton=1:100
        histpoint(newton) = currpoint;
        currvals = zeros(1,3);
        for j=1:3
            [currvals(j),pickXs] = findlikesimple(GNUM,validXs,rcvval,blockP,anatrans{currpoint+j-2});
        end
        curr1std = zeros(1,2); 
        curr1std(1) = currvals(2)-currvals(1); curr1std(2) = currvals(3)-currvals(2);
        curr2ndd = curr1std(2) - curr1std(1);
        if abs(curr1std(1)-last1std) < 0.01*abs(curr1std(1))
            break;
        else
            last1std = curr1std(1);
            currpoint = currpoint - floor(curr1std(1) / curr2ndd); 
            if currpoint > asfarasigo-2 || currpoint < 2
                newtonsearchfailed = 1;
                break;
            end
        end
    end
    if newtonsearchfailed 
        fprintf(1,'----------------------- newtonsearchfailed!\n');
        searcharray = [1:asfarasigo];
    else
        %if abs(curr2ndd) < 0.0001 currpoint = histpoint(max(newton-1,1)); end
        searcharray = [max(1,currpoint-3):min(asfarasigo,currpoint+3)];
    end
    for jidx=1:length(searcharray)
        j = searcharray(jidx);
        [likelihood(j),pickXs] = findlikesimple(GNUM,validXs,rcvval,blockP,anatrans{j});
    end
    likelihood(find(likelihood == 0)) = min(likelihood);
    [maxlikeval,errnum] = max(likelihood);

    % for sta begin
    if ~newtonsearchfailed
        EST_RECORD_peakval(iteridx) = maxlikeval;
        [endlikeval,pickXs] = findlikesimple(GNUM,validXs,rcvval,blockP,anatrans{maxerr});
        EST_RECORD_endval(iteridx) = endlikeval;
    end
    % for sta end

    % for sta begin
    sta_brickerr(iteridx) = errnum - realErrNum;
    % for sta end

    %----------------- collecting statistics begin --------------------

    %errnum = realErrNum;
    if USE_REDIR 
    if errnum < size(REDISTRI,1)
        rhere = rand(1);
        for j=0:size(REDISTRI,1)-1
            if rhere < sum(REDISTRI(1:j+1,errnum+1))
                errnum = j;
                break;
            end
        end
    end
    end    
        
    if sum(abs(rcvval-pktval)) > 0
        est_errR = errnum/M;
    else
        est_errR = 0.0005;
    end
    
    curEstErr0 = est_errR - errR;  
    curEstErr = power(curEstErr0/errR,2);
    
    EST_RECORD(iteridx) = errnum;
    if newtonsearchfailed == 0
        EST_RECORD_driv(iteridx) = mean(abs(curr1std));
    end
    EST_RECORD_realerrnum(iteridx) = realErrNum; 

    estErr = estErr + curEstErr;
    fineEstErr(iteridx) = curEstErr0; 

    %----------------- collecting statistics end   --------------------

    if mod(iteridx, SHOW_PERIOD) == 0 
        fprintf(1,'iteridx %d -- running average %f, bias %f, err ratio %f, real err num %d, est distance %d, estErr %f\n',iteridx, estErr/iteridx, sum(fineEstErr(1:iteridx))/iteridx/errR, errR, realErrNum, errnum-realErrNum,curEstErr); 
    end
end


