% CAL_ANA=1; target_errR=0.003; USE_WRAPPER=0; gEEC;

% important note: bias more than 0.05 starts at around 0.135, when scan to M/2 or M*0.75,
% most likely caused by Jeffery, when scan to M/5, starts at 0.115.

USE_INTERLEAVE = 0;
WITH_IMMUNE = 1;
SAMPLE_BIT_NUM = 85;

if USE_WRAPPER == 0
    ROUND_NUM = 10000;
    SHOW_PERIOD = 1000;
    
    %PKT_SIZE = 30000;
    PKT_SIZE = 12000;
    PKT_SIZE = 4000;
    USE_JEFF = 0;

    %PKT_SIZE 12000: with jeff
    BIT_PER_SAMP = 5; L = 512; % good

    %PKT_SIZE 4000, with jeff
    BIT_PER_SAMP = 4; L = 256; % bad bias from 0.001 till 0.005, from 0.20 to 0.038, also from 0.07 and up, -0.04..., not useful; 
    BIT_PER_SAMP = 4; L = 128; % bad bias from 0.001 till 0.01, from 0.20 to 0.034, not useful

    %PKT_SIZE 4000, with no jeff
    BIT_PER_SAMP = 4; L = 256; % 0.07 too bad 
    BIT_PER_SAMP = 4; L = 128; % bad bias from 0.001, at 0.08; other biases seems fine, best for 4000?
    BIT_PER_SAMP = 5; L = 256; % bad bias from 0.001, at 0.08; other biases seems fine, best for 4000?
end

N = floor(SAMPLE_BIT_NUM/BIT_PER_SAMP);

if USE_INTERLEAVE == 0                    
    M = PKT_SIZE;
else
    M = ceil(N*L);
end
maxerr = ceil(M*0.175);

MAX_D = ceil(power(2,BIT_PER_SAMP))-1;
MAX_Dp1 = MAX_D + 1;

% for sta begin
recordpktvals = zeros(1,ROUND_NUM*N);
% for sta end

% ----------------------------------------------------------------------
% ANA part begin
if CAL_ANA
% ----------------------------------------------------------------------

    jpr_maxerr = max(M/2,maxerr);
    matgeecanatrans = zeros(jpr_maxerr,MAX_Dp1);
    gEEC_K = MAX_Dp1;
    matOMEGA = zeros(gEEC_K,gEEC_K);
    for j=1:gEEC_K
        for  jj=1:gEEC_K
            matOMEGA(j,jj) = exp(i*2*pi*(j-1)*(jj-1)/gEEC_K);
        end
    end
    vecAlpha = zeros(1,gEEC_K);
    for j=1:gEEC_K
        vecAlpha(j) = 2 * power(sin((j-1)*pi/gEEC_K),2);
    end
    for thiserr=1:jpr_maxerr
        this_theta = thiserr / M;
        vecD = zeros(1,gEEC_K);
        for j=1:gEEC_K
            vecD(j) = 1-vecAlpha(j)*this_theta;
        end
        matgeecanatrans(thiserr,:) = real((1/gEEC_K)*power(vecD,L)*matOMEGA);
    end

    FisherInfo = zeros(1,jpr_maxerr);
    geec_Jeffery_Prior = zeros(1,jpr_maxerr);
    for thiserr=1:jpr_maxerr
        this_theta = thiserr / M;
        thisone = 0;
        for j=0:gEEC_K-1
            thisval = 0;
            for jj=1:gEEC_K-1
                tempp = L/gEEC_K*matOMEGA(jj+1,j+1) * vecAlpha(jj+1) * power(1-this_theta*vecAlpha(jj+1),L-1);
                thisval = thisval + tempp;
            end
            %thisval = real(thisval);
            thisval = power(thisval,2);
            thisone = thisone + thisval/matgeecanatrans(thiserr,j+1);
        end
        FisherInfo(1,thiserr) = thisone*power(this_theta,2);
        geec_Jeffery_Prior(1,thiserr) = sqrt(thisone); 
    end
    %geec_Jeffery_Prior(2) = geec_Jeffery_Prior(1); 
    geec_Jeffery_Prior = geec_Jeffery_Prior/sum(geec_Jeffery_Prior);

    geecanatrans = zeros(maxerr,MAX_Dp1);
    for errnum=1:maxerr
        if mod(errnum,100) == 0 
            fprintf(1,'ana cal come to errnum %d\n', errnum);
        end
        errR = errnum / M;
        thistrans = zeros(1,MAX_Dp1); thistrans(1) = 1;
        for j=1:L
            nexttrans = zeros(1,MAX_Dp1);
            for jj=0:MAX_D
                njjup = mod(jj+1,MAX_Dp1);
                njjdn = mod(jj-1,MAX_Dp1);
                nexttrans(njjup+1) = nexttrans(njjup+1) + thistrans(jj+1) * errR/2;   
                nexttrans(njjdn+1) = nexttrans(njjdn+1) + thistrans(jj+1) * errR/2;   
                nexttrans(jj+1) = nexttrans(jj+1) + thistrans(jj+1) * (1-errR);   
            end
            thistrans = nexttrans;
        end
        geecanatrans(errnum,1:MAX_Dp1) = thistrans(1:MAX_Dp1);
    end

    geec_empFisher = zeros(1,maxerr);
    for thiserr=2:maxerr-1
        thisone = 0;
        for j=0:gEEC_K-1
            thisdiff = log(geecanatrans(thiserr+1,j+1)) - log(geecanatrans(thiserr-1,j+1));
            thisderiv = thisdiff*M/2;
            thisderivsq = thisderiv*thisderiv;
            wthisderivsq = thisderivsq * matgeecanatrans(thiserr,j+1);
            thisone = thisone + wthisderivsq;
        end
        geec_empFisher(thiserr) = thisone * power(thiserr/M,2);
    end
    geec_Jeffery_Prior = geec_empFisher;
    geec_Jeffery_Prior = geec_Jeffery_Prior/sum(geec_Jeffery_Prior);
% ----------------------------------------------------------------------
end
% ANA part end
% ----------------------------------------------------------------------

EST_RECORD = [];
estErr = 0; fineEstErr = [];

errR = target_errR;
totalerrnum = round(errR*PKT_SIZE); 
for iteridx=1:ROUND_NUM

    pkt = ceil(rand(1,M)-0.5);
    
    % 3 ways of introducing errors bgn
    % 1. total err is fixed
    err = zeros(1,PKT_SIZE); tempp = randperm(PKT_SIZE); err(tempp(1:totalerrnum)) = 1;

    % 2. a ratio
    % err = ceil(rand(1,M)-(1-errR));
    
    % 3. checked part err fixed
    %err = zeros(1,M); tempp = randperm(M); err(tempp(1:ceil(errR*M))) = 1;
    % 3 ways of introducing errors end
    
    rcv = bitxor(err,pkt);
    realErrNum = sum(err);

    pktval = zeros(1,N); rcvval = zeros(1,N);
    for j=1:N
        if USE_INTERLEAVE == 0
            %tempp = randperm(M); selidx = tempp(1:L);
            tempp = rand(1,L); selidx = ceil(tempp*PKT_SIZE);
            pkt_checkarray = pkt(selidx); rcv_checkarray = rcv(selidx);
            geecsi = ceil(rand(1,L)-0.5);
            pkt_checkarray = bitxor(pkt_checkarray,geecsi);
            rcv_checkarray = bitxor(rcv_checkarray,geecsi);
        else
            bgnidx = (j-1) * L + 1; endidx = j * L;
            pkt_checkarray = pkt(bgnidx:endidx); rcv_checkarray = rcv(bgnidx:endidx);
        end
        pktval(j) = mod(sum(pkt_checkarray), MAX_Dp1);
        if WITH_IMMUNE == 0
            orig_color = dec2bin(pktval(j),BIT_PER_SAMP)-'0';
            colorerr = ceil(rand(1,BIT_PER_SAMP)-(1-errR)); 
            flip_color = bitxor(colorerr,orig_color);
            pktval(j) = sum(flip_color.*power(2,[BIT_PER_SAMP-1:-1:0]));
        end
        rcvval(j) = mod(sum(rcv_checkarray), MAX_Dp1); 
    end

    % for sta begin
    recordpktvals(floor((iteridx-1)*N)+1:floor(iteridx*N)) = pktval(1:N);
    % for sta end

    asfarasigo = floor(max(min(realErrNum*5,maxerr),1));
    asfarasigo = maxerr;
    likelihood = zeros(1,asfarasigo);
    for j=1:asfarasigo
        for jj=1:N
            thisdiff = mod(pktval(jj) - rcvval(jj), MAX_Dp1);
            thisprob = geecanatrans(j, thisdiff+1);
            likelihood(j) = likelihood(j) + log(thisprob);
        end
        if USE_JEFF
            likelihood(j) = likelihood(j) + log(geec_Jeffery_Prior(j))/2;
        end
    end
    [dummy,errnum] = max(likelihood);

    % collecting sta begin ----------------------
    EST_RECORD(iteridx) = errnum;    
    
    curEstErr0 = errnum/M-errR;  
    curEstErr = power(curEstErr0/errR,2);

    %curEstErr0 = log(errnum/M)-log(errR);  
    %curEstErr = power(curEstErr0,2);

    estErr = estErr + curEstErr;
    fineEstErr(iteridx) = curEstErr0; 

    if mod(iteridx, SHOW_PERIOD) == 0 
        fprintf(1,'iteridx %d -- running average %f, bias %f, err ratio %f, real err num %d, est distance %d, estErr %f\n',iteridx, estErr/iteridx, sum(fineEstErr(1:iteridx))/iteridx/errR, errR, realErrNum, errnum-realErrNum,curEstErr); 
    end
    % collecting sta end   ----------------------
end




