postlike_RUN_SIMU = 0; USE_RANGE = 1; DO_WRITE_FOR_C = 0; DO_NOT_EXCEED_ORIG = 1;


errmax = 380; estmax = 588; SFTNum = 101; 

einn = errmax+1;
OCNum = estmax+1; 


M=3360;

EV_WEIGHT = ones(1,errmax+1);
EV_EMPH_BGN = 1; %round(errmax/3);
EV_EMPH_END = round(errmax*2/3);

if einn > 100
    SELECT_EV_FLAG = zeros(1,einn);
    SELECT_EV_FLAG(1:36)=1;
    SELECT_EV_FLAG(37:3:100)=1;
    SELECT_EV_FLAG(101:7:end) = 1;
else
    SELECT_EV_FLAG = ones(1,einn);
end
SELECT_EV_list = find(SELECT_EV_FLAG)-1;
SELECT_EV_num = sum(SELECT_EV_FLAG);


% #########################################################################
if postlike_RUN_SIMU % to run simulations 
    wmaxerr = 672;
    USE_WRAPPER = 1;
    load anavals_BNUM80_BLEN2_21_SAMP;
    ROUND_NUM = 10000;
    SHOW_PERIOD = 100;
    SAMPLE_BIT_NUM = 80;
    estres = zeros(wmaxerr,ROUND_NUM);
    estres_driv = zeros(wmaxerr,ROUND_NUM);
    estres_realerrnum = zeros(wmaxerr,ROUND_NUM);
    estres_peakval = zeros(wmaxerr,ROUND_NUM);
    estres_endval = zeros(wmaxerr,ROUND_NUM);
    for target_errNum=1:wmaxerr
        if find(SELECT_EV_list==target_errNum) 
            USE_REDIR=0; USE_Z_FISHER=0; CAL_ANA=0; target_errR=target_errNum/3360;  geoeec3d;
            estres(target_errNum,1:ROUND_NUM) = EST_RECORD(1:ROUND_NUM);
            estres_driv(target_errNum,1:ROUND_NUM) = EST_RECORD_driv(1:ROUND_NUM);
            estres_realerrnum(target_errNum,1:ROUND_NUM) = EST_RECORD_realerrnum(1:ROUND_NUM);
            estres_peakval(target_errNum,1:ROUND_NUM) = EST_RECORD_peakval(1:ROUND_NUM);
            estres_endval(target_errNum,1:ROUND_NUM) = EST_RECORD_endval(1:ROUND_NUM);
            save estres_mEEC_S4000.mat estres estres_driv estres_realerrnum estres_peakval estres_endval;
        end
    end
end 
% #########################################################################

% #########################################################################
if postlike_RUN_SIMU==0 % to solve the lp problem

load estres_mEEC_S4000.mat % NOTE: use the file name storing the simulation result

wmaxerr = size(estres,1);
ROUND_NUM = size(estres,2);
estdistri = zeros(wmaxerr+1,wmaxerr+1);
estdistri(1,1) = ROUND_NUM;
for target_errNum=1:wmaxerr
    for zzz=1:ROUND_NUM
        esterr = estres(target_errNum,zzz);
        estdistri(target_errNum+1,esterr+1) = estdistri(target_errNum+1,esterr+1) + 1;
    end
end
estdistri = estdistri / ROUND_NUM;
estdistri = estdistri';

dbg_estdistri = estdistri(1:estmax+1,1:errmax+1);

VARNUM =  OCNum*SFTNum;

RSTART = zeros(1,OCNum);
halfrange = (SFTNum-1)/2;
for j=0:OCNum-1
    if j <= halfrange
        RSTART(j+1) = 0;
    elseif j < OCNum-halfrange
        RSTART(j+1) = j-halfrange;
    else
        RSTART(j+1) = OCNum-SFTNum;
    end
end

REDIRFLAG = zeros(OCNum,OCNum);
for j=0:estmax
    REDIRFLAG(RSTART(j+1)+1:RSTART(j+1)+SFTNum,j+1) = 1;
end

REDIRFLAG = eye(OCNum,OCNum);
for j=0:estmax
    thisshiftrange = round(max(j/2,halfrange));
    lowerhalfbgn  =  max(0,j-thisshiftrange);
    higherhalfend  = min(estmax,j+thisshiftrange);
    lowerhalfstep = (j-lowerhalfbgn)/halfrange;
    higherhalfstep = (higherhalfend-j)/halfrange;
    for jj=1:halfrange
        tempp = round(lowerhalfbgn+jj*lowerhalfstep);
        REDIRFLAG(tempp+1,j+1) = 1; 
        tempp = round(j+jj*higherhalfstep);
        REDIRFLAG(tempp+1,j+1) = 1; 
    end
end


% #########################################################################

% finding the redir matrix D
%
% if do not limit the redir range: 
%  -- D is a matrix, D(m,n) (m=0:OCNum-1, n=0:OCNum-1) is at m*OCNum+n+1
%  -- M is the effective est matrix, M(m,n) = d_rvec_m+1 * e_cvec_n+1 (m,n start from 0)
%
% if limit the redir range: 
%  -- sD = zers(1,VARNUM) with limited range, sD(m,n) (m=0:SFTNum-1,n=0:OCNum-1)
%     is at n*SFTNum+m+1, representing the D(m+RSTART(n),n), assuming RSTART(n)
%     index is 0, in other words, stored according to column

Aeq = zeros(OCNum,VARNUM); % A is the constraint matirx, 
beq = zeros(OCNum,1); 

% first is the eqality constraint, each column of the redir matrix adds to 1 
for j=0:estmax 
    for jj=0:SFTNum-1 % jj+1: row index 
        Aeq(j+1,j*SFTNum+jj+1) = 1;
    end
    beq(j+1,1) = 1;
end

Aneq = zeros(2*SELECT_EV_num,VARNUM); % A is the constraint matirx
bneq = zeros(2*SELECT_EV_num,1); 
for ev=0:errmax % for every possible actual error value
    if SELECT_EV_FLAG(ev+1) == 0 continue; end
    evidx = find(SELECT_EV_list==ev);
    for j=0:estmax % for each row 
        for jj=0:estmax % for each column
            %mapj = j-RSTART(jj+1); 
            %if mapj<0 || mapj> SFTNum-1 continue; end
            if REDIRFLAG(j+1,jj+1) == 0 continue; end 
            mapj = sum(REDIRFLAG(1:j+1,jj+1))-1;
            lochere = jj*SFTNum+mapj+1;
            Aneq(evidx,lochere) = estdistri(jj+1,ev+1)*j; % check the prior 5/20 version in save
        end
    end
    origestmean = 0;
    for jj=0:estmax
        origestmean = origestmean + estdistri(jj+1,ev+1)*jj;
    end
    allowbias = abs((origestmean-ev)/ev);
    if ev ~= 1
        if ev <=  338
            allowbias = 0.03;
        elseif ev <=  ceil(M*0.105)
            allowbias = 0.035;
        end
    end
    bneq(evidx,1) = ev*(1+allowbias);
    bneq(evidx+SELECT_EV_num,1) = -ev*(1-allowbias);
    fprintf(1,'came here ev %d,origestmean %f, allowbias %f\n', ev,origestmean,allowbias);
end
Aneq(SELECT_EV_num+1:2*SELECT_EV_num,1:VARNUM) = -Aneq(1:SELECT_EV_num,1:VARNUM);
bneq(1,1) = 0.05;
bneq(SELECT_EV_num+1,1) = 0;

size(Aneq)

if DO_NOT_EXCEED_ORIG
    for ev=33:errmax % for small packet size, start from 33, too large bias at low error ratios, have to give up on perf
    %for ev=1:errmax % for 12000 bit packet 
        if SELECT_EV_FLAG(ev+1) == 0 continue; end
        evidx = find(SELECT_EV_list==ev);
        for j=0:estmax % for each row 
            for jj=0:estmax % for each column
                %mapj = j-RSTART(jj+1); 
                %if mapj<0 || mapj> SFTNum-1 continue; end
                if REDIRFLAG(j+1,jj+1) == 0 continue; end 
                mapj = sum(REDIRFLAG(1:j+1,jj+1))-1;
                lochere = jj*SFTNum+mapj+1;
                Aneq(evidx+2*SELECT_EV_num,lochere) = estdistri(jj+1,ev+1)*power((j-ev)/ev,2); 
            end
        end
        origestmetric = 0;
        for jj=0:estmax
            origestmetric = origestmetric + estdistri(jj+1,ev+1)*power((jj-ev)/ev,2); % yes, it is jj
        end
        bneq(evidx+2*SELECT_EV_num,1) = max(origestmetric,0.11);
    end
end

f = zeros(VARNUM,1);
for ev=1:errmax
    %ev
    for j=0:estmax % for each row in M column j+1
        for jj=0:estmax
            mapj = j-RSTART(jj+1); 
            if mapj<0 || mapj> SFTNum-1 continue; end
            lochere = jj*SFTNum+mapj+1;
            f(lochere) = f(lochere) + estdistri(jj+1,ev+1)*power((j-ev)/ev,2)*EV_WEIGHT(ev+1);
        end
    end
end

fprintf(1,'problem set up done\n');

if DO_WRITE_FOR_C == 0
    x0 = zeros(VARNUM,1);
    for j=0:estmax % for each row in M column j+1
        jj=j;
        mapj = j-RSTART(jj+1); 
        lochere = jj*SFTNum+mapj+1;
        x0(lochere) = 1;
    end
    %options = optimoptions('linprog', 'Display', 'iter', 'Algorithm', 'interior-point');
    options = optimoptions('linprog', 'Display', 'iter', 'Algorithm', 'interior-point','MaxIter', 300);

    [sX,FVAL,EXITFLAG] = linprog(f,Aneq,bneq,Aeq,beq,zeros(VARNUM,1), [], x0,options);
    X = zeros(OCNum,OCNum);
    for j=0:estmax % for each row in M column j+1
        for jj=0:estmax % for each column in this row
            % mapj = j-RSTART(jj+1); 
            % if mapj<0 || mapj> SFTNum-1 continue; end
            if REDIRFLAG(j+1,jj+1) == 0 continue; end 
            mapj = sum(REDIRFLAG(1:j+1,jj+1))-1;
            lochere = jj*SFTNum+mapj+1;
            X(j+1,jj+1) = sX(lochere);
        end
    end
    REDISTRI = X;
    FDIST = REDISTRI*dbg_estdistri;

    close all;
    figure;
    PERFORMANCE = zeros(1);
    origPERFORestmaxMACE = zeros(1);
    for ev=1:errmax % for every possible actual error value
        origestmetric = 0;
        for jj=0:estmax
            origestmetric = origestmetric + FDIST(jj+1,ev+1)*power((jj-ev)/ev,2); % yes, it is jj
        end
        PERFORMANCE(ev+1) = origestmetric;
        origestmetric = 0;
        for jj=0:estmax
            origestmetric = origestmetric + estdistri(jj+1,ev+1)*power((jj-ev)/ev,2); % yes, it is jj
        end
        origPERFORMACE(ev+1) = origestmetric;
    end
    semilogx(SELECT_EV_list/M, PERFORMANCE(SELECT_EV_list+1))
    hold on;
    semilogx(SELECT_EV_list/M, origPERFORMACE(SELECT_EV_list+1),'r')
    hold off;
    
    figure;
    BIAS = zeros(1);
    origBIAS = zeros(1);
    for ev=1:errmax % for every possible actual error value
        origestmetric = 0;
        for jj=0:estmax
            origestmetric = origestmetric + FDIST(jj+1,ev+1)*jj; % yes, it is jj
        end
        BIAS(ev+1) = (origestmetric-ev)/ev;
        origestmetric = 0;
        for jj=0:estmax
            origestmetric = origestmetric + estdistri(jj+1,ev+1)*jj; % yes, it is jj
        end
        origBIAS(ev+1) = (origestmetric-ev)/ev;
    end
    semilogx(SELECT_EV_list/M, BIAS(SELECT_EV_list+1))
    hold on;
    semilogx(SELECT_EV_list/M, origBIAS(SELECT_EV_list+1),'r')
    hold off;
end

% #########################################################################
end 
% #########################################################################



